## ocaml-monolith 0~20241126

=== Makefile ===
SHELL := bash

# ------------------------------------------------------------------------------

# The name of the library.
THIS     := monolith

# The version number is automatically set to the current date,
# unless DATE is defined on the command line.
DATE     := $(shell /bin/date +%Y%m%d)

# This is used in [make release] to search CHANGES.md.
# Ideally, it should be derived from $(DATE).
DATE_WITH_SLASHES := $(shell /bin/date +%Y/%m/%d)

# The repository URL (https).
REPO     := https://gitlab.inria.fr/fpottier/$(THIS)

# The archive URL (https).
ARCHIVE  := $(REPO)/-/archive/$(DATE)/archive.tar.gz

# We assume that all of the demos (which also serve as tests)
# exist at depth two under demos/. The following command lists them.

DEMOS     = $(FIND) demos -mindepth 2 -maxdepth 2 -type d

# ------------------------------------------------------------------------------

# [make all] compiles just the library (in the current opam switch).

.PHONY: all
all:
	@ dune build @check

# [make clean] cleans up.

.PHONY: clean
clean:
	@ git clean -dfX

# ------------------------------------------------------------------------------

# [make test] runs all demos in unattended mode.

# We can use either xargs or GNU parallel,
# so as to run multiple tests either sequentially or in parallel.

# The number of jobs in parallel mode must be limited,
# otherwise afl-fuzz appears to fail.

# Every demo is expected to inhabit a subsubdirectory of demos.

# Naively running [make unattended] in every demo directory in parallel does
# not work, because this causes dune to be run in every demo directory in
# parallel, and dune apparently does not allow this. To work around this
# issue, we first compile everything using one [make all] invocation at the
# toplevel, then we run [make unattended_norebuild] in every demo directory.

# LOOP := xargs -n1
LOOP := parallel --no-notice --jobs 4

.PHONY: test
test: dependencies
	@ make clean
	@ make -f Makefile.monolith all --no-print-directory
	@ $(DEMOS) \
	  | $(LOOP) make unattended_norebuild --no-print-directory -C

# [make dependencies] installs the libraries required by the demos.

# [dune external-lib-deps] has been deprecated.
# [dune describe external-lib-deps] has appeared in Dune 3.6,
#   but produces an S-expression that is not directly usable.

# Let's just hardcode here the libraries needed by the demos.

LIBS = \
  ptmap \
  fix \
  containers containers-data \
  batteries \

.PHONY: dependencies
dependencies:
	@ for i in $$(make -f Makefile.monolith --no-print-directory switch) ; do \
	  echo "Installing dependencies in switch $$i..." ; \
	  opam install --switch $$i $(LIBS) ; \
	done

# ------------------------------------------------------------------------------

.PHONY: install
install:
	@ dune build @install
	@ dune install -p $(THIS)

.PHONY: uninstall
uninstall:
	@ dune build @install
	@ dune uninstall

.PHONY: reinstall
reinstall:
	@ make uninstall
	@ make install

.PHONY: pin
pin:
	opam pin add $(THIS) . --yes

.PHONY: unpin
unpin:
	opam pin remove $(THIS) --yes

.PHONY: repin
repin:
	@make unpin
	@make pin

# ----------------------------------------------------------------------------

# [make headache] copies a header to every source file.

# This requires a version of headache that supports UTF-8.

HEADACHE := headache
HEADER   := $(shell pwd)/header.txt

# The find utility.
FIND     := $(shell if command -v gfind >/dev/null ; \
	            then echo gfind ; else echo find ; fi)
.PHONY: headache
headache:
	$(FIND) . -regex ".*\.ml\(i\|y\|l\)?" \
	  -exec $(HEADACHE) -h $(HEADER) "{}" ";" ; \

# ----------------------------------------------------------------------------

# [make versions] compiles and tests the library under many versions of
# OCaml, whose list is specified below.

# This requires appropriate opam switches to exist. A missing switch
# can be created like this:
#   opam switch create 4.03.0

VERSIONS := \
  4.12.0 \
  4.13.1 \
  4.14.2 \
  5.0.0  \
  5.1.0  \
  5.2.0  \

.PHONY: versions
versions:
	@(echo "(lang dune 2.0)" && \
	  for v in $(VERSIONS) ; do \
	    echo "(context (opam (switch $$v)))" ; \
	  done) > dune-workspace.versions
	@ dune build --workspace dune-workspace.versions src ; \
	  result=$$? ; \
	  rm -f dune-workspace.versions ; \
	  exit $$result

# [make handiwork] runs a command in every opam switch.

.PHONY: handiwork
handiwork:
	@ current=`opam switch show` ; \
	  for v in $(VERSIONS) ; do \
	    echo "Switching to $$v..." ; \
	    opam switch $$v && \
	    eval $$(opam env) && \
	    opam install --yes afl-persistent && dune build src ; \
	  done ; \
	  opam switch $$current

# ----------------------------------------------------------------------------

DOCDIR = _build/default/_doc/_html
DOC    = $(DOCDIR)/index.html

.PHONY: doc
doc:
	@ dune build @doc
	@ echo "You can view the documentation by typing 'make view'".

.PHONY: view
view: doc
	@ echo Attempting to open $(DOC)...
	@ if command -v firefox > /dev/null ; then \
	  firefox $(DOC) ; \
	else \
	  open -a /Applications/Firefox.app/ $(DOC) ; \
	fi

.PHONY: export
export: doc
	ssh yquem.inria.fr rm -rf public_html/$(THIS)/doc
	scp -r $(DOCDIR) yquem.inria.fr:public_html/$(THIS)/doc

# ----------------------------------------------------------------------------

.PHONY: release
release:
# Make sure the current version can be compiled and installed.
	@ make uninstall
	@ make clean
	@ make install
# Check the current package description.
	@ opam lint
# Check if this is the master branch.
	@ if [ "$$(git symbolic-ref --short HEAD)" != "master" ] ; then \
	  echo "Error: this is not the master branch." ; \
	  git branch ; \
	  exit 1 ; \
	fi
# Make sure a CHANGES entry with the current date seems to exist.
	@ if ! grep $(DATE_WITH_SLASHES) CHANGES.md ; then \
	    echo "Error: CHANGES.md has no entry with date $(DATE_WITH_SLASHES)." ; \
	    exit 1 ; \
	  fi
# Check if everything has been committed.
	@ if [ -n "$$(git status --porcelain)" ] ; then \
	    echo "Error: there remain uncommitted changes." ; \
	    git status ; \
	    exit 1 ; \
	  else \
	    echo "Now making a release..." ; \
	  fi
# Create a git tag.
	@ git tag -a $(DATE) -m "Release $(DATE)."
# Upload. (This automatically makes a .tar.gz archive available on gitlab.)
	@ git push
	@ git push --tags
# Done.
	@ echo "Done."
	@ echo "If happy, please type:"
	@ echo "  \"make publish\"   to publish a new opam package"
	@ echo "  \"make export\"    to upload the documentation to yquem.inria.fr"

.PHONY: publish
publish:
# Publish an opam description.
	@ opam publish -v $(DATE) $(THIS) $(ARCHIVE) .

# Once the opam package has been published, run [make export].

.PHONY: undo
undo:
# Undo the last release (assuming it was done on the same date).
	@ git tag -d $(DATE)
	@ git push -u origin :$(DATE)

=== demos/faulty/avl/Makefile ===
# Type [make random] to perform random testing
#  and [make test] to perform fuzzing (driven by afl-fuzz).

# When driven by afl-fuzz, it can take a minute to find a counterexample. When
# working in random mode, a counterexample is usually found in a few seconds.
# [make random] performs iterated narrowing (that is, it runs forever and
# searches for ever-shorter scenarios).

include ../../../Makefile.monolith
EXPECTING_BUGS := 1
TIMEOUT   := 60
SEED_SIZE := 1000
MODE := random

=== demos/faulty/map/Makefile ===
# Type [make random] to perform random testing
#  and [make test] to perform fuzzing (driven by afl-fuzz).

# When driven by afl-fuzz, it can take a minute to find a counterexample. When
# working in random mode, a counterexample is usually found in a few seconds.
# [make random] performs iterated narrowing (that is, it runs forever and
# searches for ever-shorter scenarios).

include ../../../Makefile.monolith
EXPECTING_BUGS := 1
TIMEOUT := 60
MODE := random

=== debian/changelog ===
ocaml-monolith (0~20241126-1build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 30 Jan 2025 16:05:43 +0100

ocaml-monolith (0~20241126-1) unstable; urgency=medium

  * Initial release (Closes: #1091841)

 -- Stéphane Glondu <glondu@debian.org>  Wed, 01 Jan 2025 11:58:24 +0100

## ocaml-monolith 0~20250314

=== Makefile ===
--- 
+++ 
@@ -7,11 +7,13 @@
 
 # The version number is automatically set to the current date,
 # unless DATE is defined on the command line.
+# An example of the date format is 20241208.
 DATE     := $(shell /bin/date +%Y%m%d)
 
-# This is used in [make release] to search CHANGES.md.
-# Ideally, it should be derived from $(DATE).
-DATE_WITH_SLASHES := $(shell /bin/date +%Y/%m/%d)
+# The date, with slahes, is used in [make release] to search CHANGES.md.
+# An example is 2024/12/08.
+DATE_WITH_SLASHES := $(shell echo "${DATE}" \
+  | sed -e 's|\([0-9][0-9][0-9][0-9]\)\([0-9][0-9]\)\([0-9][0-9]\)|\1/\2/\3|')
 
 # The repository URL (https).
 REPO     := https://gitlab.inria.fr/fpottier/$(THIS)
@@ -57,11 +59,12 @@
 # toplevel, then we run [make unattended_norebuild] in every demo directory.
 
 # LOOP := xargs -n1
-LOOP := parallel --no-notice --jobs 4
+LOOP := parallel --no-notice --jobs 8 --group
 
 .PHONY: test
-test: dependencies
-	@ make clean
+test:
+#	@ make dependencies
+#	@ make clean
 	@ make -f Makefile.monolith all --no-print-directory
 	@ $(DEMOS) \
 	  | $(LOOP) make unattended_norebuild --no-print-directory -C
@@ -150,6 +153,7 @@
   5.0.0  \
   5.1.0  \
   5.2.0  \
+  5.3.0  \
 
 .PHONY: versions
 versions:

=== demos/faulty/avl/Makefile ===
--- 
+++ 
@@ -8,6 +8,5 @@
 
 include ../../../Makefile.monolith
 EXPECTING_BUGS := 1
-TIMEOUT   := 60
 SEED_SIZE := 1000
 MODE := random

=== debian/changelog ===
ocaml-monolith (0~20250314-1build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 18 Jun 2025 09:38:32 +0200

ocaml-monolith (0~20250314-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Sun, 23 Mar 2025 09:55:20 +0100

=== debian/control ===
Source: ocaml-monolith
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 ocaml-dune,
 libafl-persistent-ocaml-dev,
 libpprint-ocaml-dev,
 ocaml-odoc,
 dh-ocaml (>= 1.2)
Standards-Version: 4.7.0
Rules-Requires-Root: no
Section: ocaml
Homepage: https://gitlab.inria.fr/fpottier/monolith/
Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-monolith.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-monolith

Package: libmonolith-ocaml-dev
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocaml-findlib
Description: framework for strong random testing of OCaml libraries (dev files)
 Monolith offers facilities for **testing an OCaml library** (for
 instance, a data structure implementation) by **comparing it against
 a reference implementation**. It can be used to perform either random
 testing or fuzz testing.
 .
 This package contains development files.

Package: libmonolith-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Description: framework for strong random testing of OCaml libraries (runtime)
 Monolith offers facilities for **testing an OCaml library** (for
 instance, a data structure implementation) by **comparing it against
 a reference implementation**. It can be used to perform either random
 testing or fuzz testing.
 .
 This package contains runtime files.

## ocaml-monolith 0~20250922

=== Makefile ===
--- 
+++ 
@@ -200,8 +200,8 @@
 
 .PHONY: export
 export: doc
-	ssh yquem.inria.fr rm -rf public_html/$(THIS)/doc
-	scp -r $(DOCDIR) yquem.inria.fr:public_html/$(THIS)/doc
+	ssh yquem.paris.inria.fr rm -rf public_html/$(THIS)/doc
+	scp -r $(DOCDIR) yquem.paris.inria.fr:public_html/$(THIS)/doc
 
 # ----------------------------------------------------------------------------
 
@@ -241,7 +241,7 @@
 	@ echo "Done."
 	@ echo "If happy, please type:"
 	@ echo "  \"make publish\"   to publish a new opam package"
-	@ echo "  \"make export\"    to upload the documentation to yquem.inria.fr"
+	@ echo "  \"make export\"    to upload the documentation to yquem.paris.inria.fr"
 
 .PHONY: publish
 publish:

=== demos/faulty/bag_det/Makefile ===
include ../../../Makefile.monolith
EXPECTING_BUGS := 1

=== demos/faulty/map/Makefile ===
--- 
+++ 
@@ -8,5 +8,4 @@
 
 include ../../../Makefile.monolith
 EXPECTING_BUGS := 1
-TIMEOUT := 60
 MODE := random

=== demos/misc/memoize_simple/Makefile ===
include ../../../Makefile.monolith

=== demos/misc/seq1/Makefile ===
include ../../../Makefile.monolith
EXPECTING_BUGS := 1
MODE := random
TIMEOUT := 5

=== debian/changelog ===
ocaml-monolith (0~20250922-1) unstable; urgency=medium

  * New upstream release
  * Switch debian/watch to version 5
  * Bump Standards-Version to 4.7.2
  * Remove Rules-Requires-Root

 -- Stéphane Glondu <glondu@debian.org>  Fri, 17 Oct 2025 12:32:16 +0200

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,7 @@
  libpprint-ocaml-dev,
  ocaml-odoc,
  dh-ocaml (>= 1.2)
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.2
 Section: ocaml
 Homepage: https://gitlab.inria.fr/fpottier/monolith/
 Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-monolith.git

=== debian/watch ===
Version: 5

Source: https://gitlab.inria.fr/fpottier/monolith/tags?sort=updated_desc
Matching-Pattern: -/archive/[^/]+/monolith-@ANY_VERSION@\.tar\.gz
Searchmode: plain
Uversionmangle: s/^/0~/
